<%@ Assembly Name="Microsoft.SharePoint, Version=14.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" %>
<%@ Page Language="C#" Inherits="Microsoft.SharePoint.WebPartPages.WikiEditPage" MasterPageFile="~masterurl/default.master" %>
<%@ Register TagPrefix="SharePoint" Namespace="Microsoft.SharePoint.WebControls" Assembly="Microsoft.SharePoint, Version=14.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" %>
<%@ Import Namespace="Microsoft.SharePoint" %>
<asp:Content ContentPlaceHolderID='PlaceHolderPageTitle' runat='server'>
    Service Proxy Test Page
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderPageTitleInTitleArea' runat='server'>
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderAdditionalPageHead' runat='server'>
    <WebPartPages:AllowFraming runat="server"></WebPartPages:AllowFraming>
    <script   src="https://code.jquery.com/jquery-1.12.4.js"   integrity="sha256-Qw82+bXyGq6MydymqBxNPYTaUXXq7c8v3CwiYwLLNXU="   crossorigin="anonymous"></script>
    <!--
    @copyright 2018 Joe McShea
    @license under the MIT license:
        http://www.opensource.org/licenses/mit-license.php
    -->
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderMiniConsole' runat='server'>
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderLeftActions' runat='server'>
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderMain' runat='server'>
    <h1>Service Proxy Test Page</h1>

    <!-- button to test locally -->
    <input name="btnTest" id="btnTest" type="button" value="Test Proxy Locally">
    <br>

    <script type="text/javascript">
        // change these to match your environment
        var expectedOrigin = "https://dev.wingtip.com";
        var listTitle = "Announcements";

        // add an event handler for postMessages received
        $(window).on("message", function (e) {
            try {
                // parse the json data and use the resulting object as input to $.ajax
                callRestApi(JSON.parse(e.originalEvent.data));
            } catch (e) { alert(e); }
        });

        // call the REST end point
        function callRestApi(options) {
            // substitute the site url for ~site
            options.url = options.url.replace(
                /~site/g,
                _spPageContextInfo.webAbsoluteUrl);

            // add a request digest, the client can't do this because the digest
            // is site collection specific, we also don't really need this for a
            // GET request, but would for a POST etc.
            options.headers["X-RequestDigest"] = $("#__REQUESTDIGEST").val();

            // hook up success and error callbacks
            options.success = function (data) { sendResponse(options.url, "ok", data); }
            options.error = function (data) { sendResponse(options.url, "error", data); }

            // call $.ajax
            $.ajax(options);
        }

        // send the web service response or error as a postMessage
        function sendResponse(url, status, data) {
            // construct a response object, the web service response is in the message property
            var response = {
                url: url,
                status: status,
                message: data
            };

            if (window = window.top) {
                // we're not in a iframe, just testing locally
                alert(JSON.stringify(response, null, 4));
            }
            else {
                // otherwise, post the response to the parent frame
                parent.postMessage(
                    JSON.stringify(response),
                    expectedOrigin);
            }
        }

        $("#btnTest").click(function () {
            // call the web service locally, this is easier to debug and make sure you
            // have the Ajax options right before adding the complexity of CORS
            callRestApi({
                url: "~site/_api/web/lists/getbytitle('Announcements')",
                type: "GET",
                contentType: "application/json;odata=verbose",
                headers: {
                    "Accept": "application/json;odata=verbose"
                }
            });
        });
    </script>
</asp:Content>